Index: pjproject/trunk/pjlib-util/build/pjlib_util.vcproj
===================================================================
--- pjproject/trunk/pjlib-util/build/pjlib_util.vcproj	(revision 1062)
+++ pjproject/trunk/pjlib-util/build/pjlib_util.vcproj	(revision 1100)
@@ -5,5 +5,4 @@
 	Name="pjlib_util"
 	ProjectGUID="{FE07F272-AE7F-4549-9E9F-EF9B80CB1693}"
-	RootNamespace="pjlib_util"
 	>
 	<Platforms>
@@ -17,6 +16,6 @@
 		<Configuration
 			Name="Release|Win32"
-			OutputDirectory="./output/pjlib-util-i386-win32-vc8-release"
-			IntermediateDirectory="./output/pjlib-util-i386-win32-vc8-release"
+			OutputDirectory=".\./output/pjlib-util-i386-win32-vc6-release"
+			IntermediateDirectory=".\./output/pjlib-util-i386-win32-vc6-release"
 			ConfigurationType="4"
 			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC60.vsprops"
@@ -49,8 +48,8 @@
 				RuntimeLibrary="2"
 				EnableFunctionLevelLinking="true"
-				PrecompiledHeaderFile="./output/pjlib-util-i386-win32-vc8-release/pjlib_util.pch"
-				AssemblerListingLocation="./output/pjlib-util-i386-win32-vc8-release/"
-				ObjectFile="./output/pjlib-util-i386-win32-vc8-release/"
-				ProgramDataBaseFileName="./output/pjlib-util-i386-win32-vc8-release/"
+				PrecompiledHeaderFile=".\./output/pjlib-util-i386-win32-vc6-release/pjlib_util.pch"
+				AssemblerListingLocation=".\./output/pjlib-util-i386-win32-vc6-release/"
+				ObjectFile=".\./output/pjlib-util-i386-win32-vc6-release/"
+				ProgramDataBaseFileName=".\./output/pjlib-util-i386-win32-vc6-release/"
 				BrowseInformation="1"
 				WarningLevel="4"
@@ -71,5 +70,5 @@
 			<Tool
 				Name="VCLibrarianTool"
-				OutputFile="../lib/pjlib-util-i386-win32-vc8-release.lib"
+				OutputFile="../lib/pjlib-util-i386-win32-vc6-release.lib"
 				SuppressStartupBanner="true"
 			/>
@@ -83,5 +82,5 @@
 				Name="VCBscMakeTool"
 				SuppressStartupBanner="true"
-				OutputFile="./output/pjlib-util-i386-win32-vc8-release/pjlib_util.bsc"
+				OutputFile=".\./output/pjlib-util-i386-win32-vc6-release/pjlib_util.bsc"
 			/>
 			<Tool
@@ -94,6 +93,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="./output/pjlib-util-i386-win32-vc8-debug"
-			IntermediateDirectory="./output/pjlib-util-i386-win32-vc8-debug"
+			OutputDirectory=".\./output/pjlib-util-i386-win32-vc6-debug"
+			IntermediateDirectory=".\./output/pjlib-util-i386-win32-vc6-debug"
 			ConfigurationType="4"
 			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC60.vsprops"
@@ -125,8 +124,8 @@
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
-				PrecompiledHeaderFile="./output/pjlib-util-i386-win32-vc8-debug/pjlib_util.pch"
-				AssemblerListingLocation="./output/pjlib-util-i386-win32-vc8-debug/"
-				ObjectFile="./output/pjlib-util-i386-win32-vc8-debug/"
-				ProgramDataBaseFileName="./output/pjlib-util-i386-win32-vc8-debug/"
+				PrecompiledHeaderFile=".\./output/pjlib-util-i386-win32-vc6-debug/pjlib_util.pch"
+				AssemblerListingLocation=".\./output/pjlib-util-i386-win32-vc6-debug/"
+				ObjectFile=".\./output/pjlib-util-i386-win32-vc6-debug/"
+				ProgramDataBaseFileName=".\./output/pjlib-util-i386-win32-vc6-debug/"
 				BrowseInformation="1"
 				WarningLevel="4"
@@ -147,5 +146,5 @@
 			<Tool
 				Name="VCLibrarianTool"
-				OutputFile="../lib/pjlib-util-i386-win32-vc8-debug.lib"
+				OutputFile="../lib/pjlib-util-i386-win32-vc6-debug.lib"
 				SuppressStartupBanner="true"
 			/>
@@ -159,5 +158,5 @@
 				Name="VCBscMakeTool"
 				SuppressStartupBanner="true"
-				OutputFile="./output/pjlib-util-i386-win32-vc8-debug/pjlib_util.bsc"
+				OutputFile=".\./output/pjlib-util-i386-win32-vc6-debug/pjlib_util.bsc"
 			/>
 			<Tool
@@ -179,4 +178,22 @@
 				RelativePath="..\src\pjlib-util\crc32.c"
 				>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
 			</File>
 			<File
@@ -271,8 +288,44 @@
 				RelativePath="..\src\pjlib-util\hmac_md5.c"
 				>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
 			</File>
 			<File
 				RelativePath="..\src\pjlib-util\hmac_sha1.c"
 				>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
 			</File>
 			<File
@@ -393,4 +446,22 @@
 				RelativePath="..\src\pjlib-util\sha1.c"
 				>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
 			</File>
 			<File
@@ -419,8 +490,44 @@
 				RelativePath="..\src\pjlib-util\stun_simple.c"
 				>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
 			</File>
 			<File
 				RelativePath="..\src\pjlib-util\stun_simple_client.c"
 				>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+					/>
+				</FileConfiguration>
 			</File>
 			<File